/* Tabela CODFISCOPER: Cdigo Fiscal de Operao */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CODFISCOPER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Cdigo Fiscal de Operao,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_CODFISCOPER
AFTER DELETE OR INSERT OR UPDATE
ON CODFISCOPER FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(300);
  V_DTOPER    DATE;
  V_CDARVPROD    VARCHAR2(20);
  V1_CDARVPROD   VARCHAR2(20);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || 'Empr=' || :OLD.CDEMPRESA;
      END IF;

      IF :OLD.IDENTSAICFOP IS NOT NULL THEN
         V_DESC := V_DESC || ' EntrSaid=' || :OLD.IDENTSAICFOP;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscEsta=' || :OLD.CDINSCESTA;
      END IF;

      IF :OLD.CDPRODUTO IS NOT NULL THEN
         SELECT MAX(CDARVPROD) INTO V_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :OLD.CDPRODUTO;
         IF V_CDARVPROD IS NOT NULL THEN
           V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
         END IF;
      END IF;

      IF :OLD.CDFISCOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' CFOp=' || :OLD.CDFISCOPER;
      END IF;

      IF :OLD.CDSUFXCFOP IS NOT NULL THEN
         V_DESC := V_DESC || ' SufxCFOp=' || :OLD.CDSUFXCFOP;
      END IF;

      IF :OLD.CDGRUPOFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' GrupFisc=' || :OLD.CDGRUPOFISC;
      END IF;

      IF :OLD.DTVALIDCFOP IS NOT NULL THEN
         V_DESC := V_DESC || ' DtIniVal=' || :OLD.DTVALIDCFOP;
      END IF;

      IF :OLD.IDDIFEALIQ IS NOT NULL THEN
         V_DESC := V_DESC || ' DifeAliq=' || :OLD.IDDIFEALIQ;
      END IF;
      
      IF :OLD.IDDIFALIQCUSPR IS NOT NULL THEN
         V_DESC := V_DESC || ' DifeAliqCusPr=' || :OLD.IDDIFALIQCUSPR;
      END IF;

      IF :OLD.CDMODDOCFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' ModDocFis=' || :OLD.CDMODDOCFISC;
      END IF;

      IF :OLD.IDCFOPINTEREST IS NOT NULL THEN
         V_DESC := V_DESC || ' OperIntEst=' || :OLD.IDCFOPINTEREST;
      END IF;
      
      IF :OLD.DsCdFiscOper IS NOT NULL THEN
         V_DESC := V_DESC || ' Desc=' || :OLD.DsCdFiscOper;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.NRINCIDCFOP;
   ELSE
      IF UPDATING THEN
         SELECT MAX(CDARVPROD) INTO V1_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :NEW.CDPRODUTO; 
         IF (:NEW.CDEMPRESA      <> :OLD.CDEMPRESA)     OR
            (:NEW.IDENTSAICFOP   <> :OLD.IDENTSAICFOP)  OR
            (:NEW.CDTIPOOPER     <> :OLD.CDTIPOOPER)    OR
            (:NEW.CDINSCESTA     <> :OLD.CDINSCESTA)    OR
            (:NEW.CDPRODUTO      <> :OLD.CDPRODUTO)     OR
            (:NEW.CDFISCOPER     <> :OLD.CDFISCOPER)    OR
            (:NEW.CDSUFXCFOP     <> :OLD.CDSUFXCFOP)    OR
            (:NEW.CDGRUPOFISC    <> :OLD.CDGRUPOFISC)   OR
            (:NEW.DTVALIDCFOP    <> :OLD.DTVALIDCFOP)   OR
            (:NEW.IDDIFEALIQ     <> :OLD.IDDIFEALIQ)    OR
            (:NEW.CDMODDOCFISC   <> :OLD.CDMODDOCFISC)  OR
            (:NEW.IDCFOPINTEREST <> :OLD.IDCFOPINTEREST)OR
            (:NEW.DsCdFiscOper   <> :OLD.DsCdFiscOper)  OR
            (:NEW.IDDIFALIQCUSPR <> :OLD.IDDIFALIQCUSPR)THEN

            V_TIPO   := '2';
            V_ITPESQ := :OLD.NRINCIDCFOP;
         END IF;
      ELSE
         SELECT MAX(CDARVPROD) INTO V1_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :NEW.CDPRODUTO;   
         V_TIPO   := '1';
         V_ITPESQ := :NEW.NRINCIDCFOP;
      END IF;

      IF :NEW.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || 'Empr=' || :NEW.CDEMPRESA;
      END IF;

      IF :NEW.IDENTSAICFOP IS NOT NULL THEN
         V_DESC := V_DESC || ' EntrSaid=' || :NEW.IDENTSAICFOP;
      END IF;

      IF :NEW.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoOper=' || :NEW.CDTIPOOPER;
      END IF;

      IF :NEW.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscEsta=' || :NEW.CDINSCESTA;
      END IF;

      IF V1_CDARVPROD IS NOT NULL THEN
         V_DESC := V_DESC || ' Prod=' || V1_CDARVPROD;
      END IF;


      IF :NEW.CDFISCOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' CFOp=' || :NEW.CDFISCOPER;
      END IF;

      IF :NEW.CDSUFXCFOP IS NOT NULL THEN
         V_DESC := V_DESC || ' SufxCFOp=' || :NEW.CDSUFXCFOP;
      END IF;

      IF :NEW.CDGRUPOFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' GrupFisc=' || :NEW.CDGRUPOFISC;
      END IF;

      IF :NEW.DTVALIDCFOP IS NOT NULL THEN
         V_DESC := V_DESC || ' DtIniVal=' || :NEW.DTVALIDCFOP;
      END IF;

      IF :NEW.IDDIFEALIQ IS NOT NULL THEN
         V_DESC := V_DESC || ' DifeAliq=' || :NEW.IDDIFEALIQ;
      END IF;
      
      IF :NEW.IDDIFALIQCUSPR IS NOT NULL THEN
         V_DESC := V_DESC || ' DifeAliqCusPr=' || :NEW.IDDIFALIQCUSPR;
      END IF;

      IF :NEW.CDMODDOCFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' ModDocFis=' || :NEW.CDMODDOCFISC;
      END IF;

      IF :NEW.IDCFOPINTEREST IS NOT NULL THEN
          V_DESC := V_DESC || ' OperIntEst=' || :NEW.IDCFOPINTEREST;
      END IF;
      
      IF :NEW.DsCdFiscOper IS NOT NULL THEN
         V_DESC := V_DESC || ' Desc=' || :NEW.DsCdFiscOper;
      END IF;  
  
   END IF;
   
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER,
                DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CODFISCOPER',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_CODFISCOPER','5.25.000'); END;
/
